Subject: PMP> RE: prtChannelType proposal for WS-Print

From: "Zehler, Peter" <[email-masked]>
Date: Thu, 1 Nov 2007 05:59:08 -0400

All,

Here are the 4 changes that have been proposed.  I have updated the text
in the included mail note below.

1) Change chWsPrint to chWSPrint

2) Change Keyword: Device UUID to Keyword: DeviceUUID

3) Make WS-Print Device ID optional

4) Make WS-Print Service ID optional

The other question I have is what should be used for the value of
prtChannelProtocolVersion?

a)      "Web Services on Devices Printer, v1.0"

b)      "http://schemas.microsoft.com/windows/2006/08/wdp/print"

c)      "WSPrint:
http://schemas.microsoft.com/windows/2006/08/wdp/print"

Pete

Peter Zehler
XEROX
Xerox Research Center Webster
Email: [email-masked]
Voice: (585) 265-8755
FAX: (585) 265-7441
US Mail: Peter Zehler
Xerox Corp.
800 Phillips Rd.
M/S 128-25E
Webster NY, 14580-9701 

________________________________

From: Zehler, Peter 
Sent: Wednesday, October 31, 2007 2:30 PM
To: [email-masked]'
Cc: 'Mike Fenelon'
Subject: prtChannelType proposal for WS-Print

All,

Below is my proposal for the extension of PrtChannelTypeTC to cover
WS-Print capable devices.

Comments?

Pete

________________________________________________

chWSPrint(46), -- Not in RFC 3805

-- Web Services on Devices Printer (WS-Print),

-- (WS-Print 1.0 - see [WS-Print])

--

-- WS-Print Service URL

-- Keyword: Address

-- Syntax: URI (Unicode UTF-8 per

-- [RFC2396])

-- Status: Mandatory

-- Multiplicity: Single

-- Default: not applicable

-- Description: URI of this WS-Print Printer

-- within Internet naming scope. Unicode

-- UTF-8 [RFC3629] string with

-- hexadecimal escapes for any non-ASCII

-- characters (per [RFC2396]).

-- Conformance: A WS-Print Printer shall list

-- all URLs it supports (one per Channel

-- entry). 

--

-- WS-Print Device ID

-- Keyword: DeviceUUID

-- Syntax: OCTET STRING (SIZE(0..63)

-- Status: Optional

-- Multiplicity: Single

-- Default: not applicable

-- Description: Globally unique protocol 

-- independent identifier for the device

-- hosting the WS-Print Printer

-- (per [RFC4122]).

--

--

-- WS-Print Service ID

-- Keyword: ServiceId

-- Syntax: URI (Unicode UTF-8 per

-- [RFC2396])

-- Status: Optional

-- Multiplicity: Single

-- Default: not applicable

-- Description: Identifier for the 

--  host which MUST be persisted 

-- across re-initialization and MUST NOT 

-- be shared across multiple Host elements.

-- Conformance: This value should be 

-- compared directly, as a case-sensitive 

-- string, with no attempt to make a relative 

-- URI into an absolute URI, to process escape 

-- sequences or to otherwise canonicalize it. 

-- (See [DEVPROF])

--

[WS-Print] Microsoft Corporation, "Print Service Definition Version 1.0
For Web Services on Devices ", November 2006, (See
http://www.microsoft.com/whdc/rally/wsdspecs.mspx)

[RFC 4122] P. Leach, et al, "A Universally Unique Identifier (UUID) URN
Namespace," July 2005. (See http://www.ietf.org/rfc/rfc4122.txt)

[DEVPROF] - J. Schlimmer, et all,  "Devices Profile for Web Services",
February 2006.

(See http://specs.xmlsoap.org/ws/2006/02/devprof/devicesprofile.pdf )   

________________________________________________

Peter Zehler
XEROX
Xerox Research Center Webster
Email: [email-masked]
Voice: (585) 265-8755
FAX: (585) 265-7441
US Mail: Peter Zehler
Xerox Corp.
800 Phillips Rd.
M/S 128-25E
Webster NY, 14580-9701 

________________________________

From: Zehler, Peter 
Sent: Tuesday, October 30, 2007 7:00 PM
To: [email-masked]'
Cc: 'Mike Fenelon'
Subject: prtChannelType for WS-Print

All,

I would like to see chWsPrint(46) registered for the WS-Print print
channel.  What would have to be done to accomplish this?  I would also
like to see the prtChannelProtocolVersion be defined to hold the target
namespace for the protocol.

Pete

Peter Zehler
XEROX
Xerox Research Center Webster
Email: [email-masked]
Voice: (585) 265-8755
FAX: (585) 265-7441
US Mail: Peter Zehler
Xerox Corp.
800 Phillips Rd.
M/S 128-25E
Webster NY, 14580-9701

---

From: "Ira McDonald" <[email-masked]>
Date: Thu, 1 Nov 2007 11:24:15 -0400

Hi Pete,

Comments:

(1) RFC 2396 (in syntaxes) is obsoleted by RFC 3986.

(2) I suggest that instead of 'Address' (somewhat inaccurate), the
    keyword for WS-Print Service URL be 'ServiceURI' - consistent with
    other existing channels and with the PWG Port Monitor MIB.

(3) Syntax for DeviceUUID should be changed to
    'URI (Unicode UTF-8 per RFC 3986)'
    - consistent with other channels and RFC 4122 (your reference)
    - note that OCTET STRING is BINARY and illegal in human-readable
    prtChannelInfo object (which must be string parseable).

Cheers,
- Ira

On 11/1/07, Zehler, Peter <[email-masked]> wrote:
>
>
>
>
> All,
>
>
>
> Here are the 4 changes that have been proposed.  I have updated the text in
> the included mail note below.
>
> b)
> "http://schemas.microsoft.com/windows/2006/08/wdp/print"
>
> c)      "WSPrint:
> Below is my proposal for the extension of PrtChannelTypeTC to cover WS-Print
> capable devices.
>
> Comments?
>
> Pete
>
> [WS-Print] Microsoft Corporation, "Print Service Definition Version 1.0 For
> Web Services on Devices ", November 2006, (See
> [DEVPROF] – J. Schlimmer, et all,  "Devices Profile for Web Services",
> February 2006.
>
> (See
> http://specs.xmlsoap.org/ws/2006/02/devprof/devicesprofile.pdf
> )
>
> I would like to see chWsPrint(46) registered for the WS-Print print channel.
>  What would have to be done to accomplish this?  I would also like to see
> the prtChannelProtocolVersion be defined to hold the target namespace for
> the protocol.
>
> Pete
>
>
>
> Peter Zehler
>  XEROX

-- 
Ira McDonald (Musician / Software Architect)
Chair - Linux Foundation Open Printing WG
Blue Roof Music / High North Inc
PO Box 221  Grand Marais, MI  49839
work: +1-906-494-2434
home: +1-906-494-2697
email: [email-masked]

---

From: "Zehler, Peter" <[email-masked]>
Date: Thu, 1 Nov 2007 11:48:44 -0400

Comments below and updated proposal

Peter Zehler
XEROX

-----Original Message-----
From: Ira McDonald [mailto:[email-masked]] 
Sent: Thursday, November 01, 2007 11:24 AM
To: Zehler, Peter; Ira McDonald
Cc: [email-masked]; Mike Fenelon
Subject: Re: PMP> RE: prtChannelType proposal for WS-Print

Hi Pete,

Comments:

<PZ>OK</PZ>

(2) I suggest that instead of 'Address' (somewhat inaccurate), the
    keyword for WS-Print Service URL be 'ServiceURI' - consistent with
    other existing channels and with the PWG Port Monitor MIB.
<PZ>I choose Adress based on the WS-Transfer/WS-MetadataExchange
elemenat name in Relationships.  I can live with ServiceURI.  It should
be noted that the multiplicity is probably wrong since the Service can
be available at multiple URLs (e.g. IPv4 and IPv6 IP addresses in a
URL).  And yes I know that is not a good idea but it happens in
unmanaged networks.</PZ> 

(3) Syntax for DeviceUUID should be changed to
    'URI (Unicode UTF-8 per RFC 3986)'
    - consistent with other channels and RFC 4122 (your reference)
    - note that OCTET STRING is BINARY and illegal in human-readable
    prtChannelInfo object (which must be string parseable).
<PZ>That is what I originally had.  As long as a value such as
'uuid:172582cc-4dc4-4786-abc2-d1c307123ac6' is valid it works for
me.</PZ>

Cheers,
- Ira

Updated proposal:

--

-- WS-Print Service URL

-- Keyword: ServiceURI

-- [RFC3986])

-- Status: Mandatory

-- Multiplicity: Multiple

-- characters (per [RFC3986]).

-- entry). 

--

-- WS-Print Device ID

-- Keyword: DeviceUUID

-- Syntax: 'URI (Unicode UTF-8 per RFC 3986)

-- Status: Optional

-- Multiplicity: Single

-- (per [RFC4122]).

--

--

-- WS-Print Service ID

-- Keyword: ServiceId

-- [RFC3986])

-- Status: Optional

-- Multiplicity: Single

-- (See [DEVPROF])

--

>  Email: [email-masked]
WS-Print
> Pete
channel.

---

From: "Ira McDonald" <[email-masked]>
Date: Thu, 1 Nov 2007 14:10:14 -0400

Hi Pete,

Comments inline in your reply below.

All on [email-masked] - this thread is the online review of a new
prtChannelType for Microsoft's WS Print protocol.

Cheers,
- Ira

> URL).  And yes I know that is not a good idea but it happens in

<Ira>  Agreed - Multiplicity should be 'Multiple' - it's an obvious bug
in 'chIPP' (which I wrote with Tom Hastings) where we said 'Single',
because the later Conformance says you should list *all* URI.
And 'ServiceURI' corresponds to 'ppmPortServiceNameOrURI'
</Ira>

> 'uuid:172582cc-4dc4-4786-abc2-d1c307123ac6' is valid it works for

<Ira> Yes - it works fine.  Note that the actual value is supposed to
be 'urn:uuid:...' (per RFC 4122).  The IANA registered scheme name is
'urn:uuid:' *not* just 'uuid:'.
<Ira>